Require Import logic.
Definition commutative : forall (A:Type), (A -> A -> A) -> Prop := fun (A:Type) => fun (f:(A -> A -> A)) => forall (x:A), forall (y:A), logic.eq (A) (f x y) (f y x).
Definition associative : forall (A:Type), (A -> A -> A) -> Prop := fun (A:Type) => fun (f:(A -> A -> A)) => forall (x:A), forall (y:A), forall (z:A), logic.eq (A) (f (f x y) z) (f x (f y z)).
Definition distributive : forall (A:Type), (A -> A -> A) -> (A -> A -> A) -> Prop := fun (A:Type) => fun (f:(A -> A -> A)) => fun (g:(A -> A -> A)) => forall (x:A), forall (y:A), forall (z:A), logic.eq (A) (f x (g y z)) (g (f x y) (f x z)).
